---
title: Rotate OAuth Client Secret
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[IAM](https://developers.cloudflare.com/api/go/resources/iam)

[OAuth Clients](https://developers.cloudflare.com/api/go/resources/iam/subresources/oauth_clients)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Rotate OAuth Client Secret

client.IAM.OAuthClients.RotateSecret(ctx, oauthClientID, body) (\*[OAuthClientRotateSecretResponse](<https://developers.cloudflare.com/api/go/resources/iam#(resource)%20iam.oauth_clients%20%3E%20(model)%20OAuthClientRotateSecretResponse%20%3E%20(schema)>), error)

POST/accounts/{account\_id}/oauth\_clients/{oauth\_client\_id}/rotate\_secret

Creates a second client secret so you can update your client configuration before deleting the old one. The `has_rotated_secret` field on the client will be set to `true`.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`OAuth Client Write`

##### ParametersExpand Collapse

oauthClientID string

The unique identifier for an OAuth client.

[Link to this property](<#(resource)%20iam.oauth_clients%20%3E%20(method)%20rotate_secret%20%3E%20(params)%20default%20%3E%20(param)%20oauth_client_id%20%3E%20(schema)>)

<details>

<summary>

body OAuthClientRotateSecretParams

</summary>

AccountID param.Field\[string]

Account identifier tag.

maxLength32

minLength32

<a href="#(resource)%20iam.oauth_clients%20%3E%20(method)%20rotate_secret%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

</details>

[Link to this property](<#(resource)%20iam.oauth_clients%20%3E%20(method)%20rotate_secret%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type OAuthClientRotateSecretResponse struct{…}

</summary>

ClientSecret stringOptional

The new client secret.

<a href="#(resource)%20iam.oauth_clients%20%3E%20(model)%20OAuthClientRotateSecretResponse%20%3E%20(schema)%20%3E%20(property)%20client_secret">Link to this property</a>

</details>

[Link to this property](<#(resource)%20iam.oauth_clients%20%3E%20(model)%20OAuthClientRotateSecretResponse%20%3E%20(schema)>)

### Rotate OAuth Client Secret

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/iam"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  response, err := client.IAM.OAuthClients.RotateSecret(
    context.TODO(),
    "a1b2c3d4e5f6a1b2c3d4e5f6a1b2c3d4",
    iam.OAuthClientRotateSecretParams{
      AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", response.ClientSecret)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "client_secret": "cf-oauth-secret-new-example"
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "client_secret": "cf-oauth-secret-new-example"
  }
}
```